PCI Compliance Release 1.6.6 API
November 24, 2025
Before understanding the API release highlights, learn more about the API server URL to be used in your API requests by referring to the Know Your Qualys API Server URL section. For these API Release Notes, <qualys_base_url> is mentioned in the sample API requests.
New Feature — OIDC Authentication for PCI Merchant APIs
With this release, we have upgraded our API security by incorporating OpenID Connect for Qualys API authentication and authorization. When OpenID Connect API authentication is implemented, IdP is used for user authentication and JWT token generation for the Qualys API access.
Key Updates
- Seamless integration of OpenID Connect to enhance API authentication and authorization measures.
- Compatibility with current identity providers and authentication to facilitate a seamless integration experience.
- This authentication is supported by all Qualys APIs.
- It eliminates the need for users to provide a username and password. This streamlines Qualys API access by allowing users to use JWT tokens, bypassing the hassle associated with usernames and passwords.
Enable OpenID Connect API Authentication
This feature is not available by default. Contact Qualys support to enable it for your subscription. You must follow the onboarding process. This feature requires IdP.
Benefits
- Enhanced API security: OpenID Connect (OIDC) uses tokens to establish a user's identity and grant access.
- Standardized access control: OpenID Connect (OIDC) provides a standardized way to manage user identities and access control
- Centralized Authentication: By enabling IdP-initiated SSO, users can authenticate once through your organization’s Identity Provider (IdP) and gain access to all the necessary APIs without needing to log in again. This simplifies the user experience and reduces password fatigue, making access faster and more secure.
- Compliance and Security: Helps to meet compliance requirements by ensuring that user authentication processes adhere to established security protocols like SAML and OIDC.
Prerequisites
You must have the following details to set up the OIDC API Authentication:
- IdP Name: The name of the Identity Provider (IdP) being configured. This can be a custom name or provided by the customer.
Example: "TestNameforIDP Qualys Internal"
- Entity ID: The unique identifier for the customer’s IdP. Typically, this is a URN or URL that serves as the IdP’s primary identifier during OIDC communications.
Example: "https://example.com/idp"
- Single Sign-On (SSO) URL: The URL where authentication requests will be sent. This is the endpoint where users are redirected to authenticate with the customer’s IdP.
Example: "https://example.com/login"
- Single Logout (SLO) URL (if applicable): The URL for handling logout requests. If you support Single Logout, this endpoint will manage the termination of sessions both at the IdP and within Qualys.
Example: "https://example.com/logout"
- SSO Exit URL (optional): The URL where users will be redirected after successful authentication.
- Certificates: Public signing certificates for verifying the authenticity of SAML responses. Up to 3 certificates can be provided. The certificate must be in X.509 format (usually in .pem or .cer files).
Onboarding Process
To start using OpenID Connect API authentication, the following onboarding process must be completed.
- Contact Qualys Support to request OpenID Connect API authentication activation for your subscription. A CRM ticket is automatically created and is used as a reference and tracking for all discussions concerning the activation.
- Qualys Support replies to the ticket to share and request the required technical information used to enable OIDC. see the Prerequisites for the details.
- Upon receipt of the response, Qualys enables OpenID Connect API authentication support. This process takes approximately one week to complete.
- Once Qualys completes the OIDC Authentication setup, request PCI admin to enable the OIDC access for your PCI Merchant user.
- Next, in the PCI Merchant user interface, enable SAML at user level and add an external ID for user mapping. To learn more, refer to Enable SAML for PCI Merchant.
Use OpenID Connect API Authentication
Once the onboarding process is complete and the OpenID Connect API authentication is enabled, you can begin using it. To start using it, you must first generate the JWT token and then use that token to execute the Qualys APIs. The following subsections provide API request and response samples for generating a JWT token and executing APIs using this token.
Generate JWT TokenGenerate JWT Token
The following sample illustrates generating JWT tokens required for accessing Qualys APIs.
API Request
curl --location '<<token generation url>>' JWT Token
--header 'Content-Type: application/x-www-form-urlencoded' JWT Token
--data-urlencode 'grant_type=password' JWT Token
--data-urlencode 'username=<<Qualys_okta_sandbox_user_id>>' JWT Token
--data-urlencode 'password=<<Qualys_okta_sandbox_password>>' \
--data-urlencode 'client_id=<<Qualys_okta_sandbox_application_client_id>>' \
--data-urlencode 'scope=openid profile'
The token generation URL may vary based on the IdP application you are using. The sample below illustrates the request and response for Okta.
API Response
{
"token_type": "Bearer",
"expires_in": 3600,
"access_token": "<JWT token value",
"scope": "profile openid",
"id_token": "<JWT token value>"
}
Sample: Use JWT Token for PCI Merchant API AuthenticationSample: Use JWT Token for PCI Merchant API Authentication
The following sample illustrates using JWT token for PCI Merchant API Authentication.
API Request
curl --location --globoff 'https://qualysapi.p01.eng.sjc01.qualys.com/pci/scan/list?limit=10' \
--header 'Content-Type: application/json' \
--header 'X-Requested-With: test' \
--header 'Authorization: Bearer eyJraWQiOiJnbGhramRmc2F.......OqUA_r4hhg'
API Response
{
"responseApiVersion": "LATEST",
"data":
{
"totalCount": 1267,
"fetchRange": "1-10",
"scanInfoList":
[ {
"scanId": 9094,
"title": "a",
"status": "Failed",
"date": "December 18, 2020 at 07:54 AM GMT",
"scanType": "DNS",
"compliance": "Fail"
},
{
"scanId": 9093,
"title": "a",
"status": "Running",
"date": "December 18, 2020 at 07:54 AM GMT",
"scanType": "DNS",
"compliance": "Fail"
},
{
"scanId": 9092,
"title": "a",
"status": "Failed",
"date": "December 18, 2020 at 07:50 AM GMT",
"scanType": "DNS",
"compliance": "Fail"
},
{
"scanId": 9091,
"title": "a",
"status": "Failed",
"date": "December 18, 2020 at 07:50 AM GMT",
"scanType": "IP",
"compliance": "Fail"
},
{
"scanId": 9090,
"title": "a",
"status": "Launch Requested",
"date": "December 18, 2020 at 07:44 AM GMT",
"scanType": "DNS",
"compliance": "Fail"
}
]
}
}